<div class="form-horizontal">
    <div class="form-group">
        <label for"reservation" class="col-sm-3 control-label">Reservation:</label>
        <div class="col-sm-9">
            <select class="form-control" name="reservation" id="reservations">
            </select>
        </div>
    </div>
    <div class="form-group">
        <label for"account" class="col-sm-3 control-label">Account:</label>
        <div class="col-sm-9">
            <select class="form-control" name="account" id="accounts" required>
            </select>
        </div>
    </div>
    <div class="form-group">
        <label for"partition" class="col-sm-3 control-label">Partition:</label>
        <div class="col-sm-9">
            <select class="form-control" name="partition" id="partitions" required>
            </select>
        </div>
    </div>
    <div class="form-group">
        <label for="cpu" class="col-sm-3 control-label">CPU(s):</label>
        <div class="col-sm-9">
            <input type="number" class="form-control" name="cpu" value="1" min="1">
        </div>
    </div>
    <div class="form-group">
        <label for="memory" class="col-sm-3 control-label">Memory (in GB):</label>
        <div class="col-sm-9">
            <input type="number" class="form-control" name="memory" value="1" min="1">
        </div>
    </div>
    <div class="form-group">
        <label for="gres_qty" class="col-sm-3 control-label">GPU(s):</label>
        <div class="col-sm-2">
            <input type="number" min="0" max="5" class="form-control" name="gres_qty" id="gres_qty" value="0">
        </div>
        <div class="col-sm-7">
            <select class="form-control" name="gres" id="gres">
            </select>
        </div>
    </div>
</div>

<script>
let accounts = {
  {% for account, partitions in accounts.items() %}
  '{{account}}': [{% for partition in partitions %}'{{partition}}',{% endfor %}],
  {% endfor %}};

let gres = {
  {% for partition, gpus in gres.items() %}
  '{{partition}}': [{% for gpu in gpus %}'{{gpu}}',{% endfor %}],
  {% endfor %}};

let reservations = {
  {% for reservation, properties in reservations.items() %}
  '{{reservation}}': {
    'accounts': [{% for account in properties['accounts'] %}'{{account}}',{% endfor %}],
    'partition': '{{ properties['partition'] if properties['partition'] is not none }}'
  },
  {% endfor %}};

let default_account = '{{default_account}}';
let default_partition = '{{default_partition}}';

var $reservations_dropdown = $("#reservations");
var $accounts_dropdown = $("#accounts");
var $partitions_dropdown = $("#partitions");
var $gres_dropdown = $("#gres");

function load_partitions() {
  $partitions_dropdown.empty();
  let account = $accounts_dropdown.val();
  let reservation = $reservations_dropdown.val();

  let partitions = accounts[account];
  if (reservation != '' && reservation != null && reservations[reservation]['partition'] != '') {
    partitions = [reservations[reservation]['partition']]
  }

  partitions.forEach(function (item, index, array) {
    $partitions_dropdown.append($("<option />").val(item).text(item));
  });
  if (partitions.includes(default_partition)) {
    $partitions_dropdown.val(default_partition);
  }
  load_gres();
}

function load_gres() {
  $gres_dropdown.empty();
  $("#gres_qty").val(0);
  let current_partition = $partitions_dropdown.val();
  if (gres[current_partition].length > 0) {
    gres[current_partition].forEach(function (item, index, array) {
      $gres_dropdown.append($("<option />").val(item).text(item));
    });
    $gres_dropdown.prop("disabled", false);
    $("#gres_qty").prop("disabled", false);
    $("#gres_qty").val(1);
  }
  else {
    $gres_dropdown.prop("disabled", true);
    $("#gres_qty").prop("disabled", true);
    $gres_dropdown.append($("<option />").val("").text("No GRES"));
    $("#gres_qty").val(0);
  }
}

function load_accounts(accounts_list, selected_account) {
  $accounts_dropdown.empty();
  accounts_list.forEach(function (item, index, array) {
    $accounts_dropdown.append($("<option />").val(item).text(item));
  });
  if (accounts_list.includes(selected_account)) {
    $accounts_dropdown.val(selected_account);
  }
  else if (accounts_list.includes(default_account)) {
    $accounts_dropdown.val(default_account);
  }
  load_partitions();
}

function set_for_reservation() {
  reservation = $reservations_dropdown.val();
  if (reservation != "") {
    properties = reservations[reservation];
    if (properties['accounts'].length > 0) {
      load_accounts(properties['accounts'], $accounts_dropdown.val());
    }
    if (properties['partition'] != '') {
      $partitions_dropdown.empty();
      $partitions_dropdown.append($("<option />").val(properties['partition']).text(properties['partition']));
      load_gres();
    }
  }
  else {
    load_accounts(Object.keys(accounts), $accounts_dropdown.val());
  }
}

$accounts_dropdown.change(load_partitions);
$partitions_dropdown.change(load_gres);
load_accounts(Object.keys(accounts), default_account);

$reservations_dropdown.append($("<option />").val('').text("No reservation")); ``
$reservations_dropdown.change(set_for_reservation);
for (const [reservation, properties] of Object.entries(reservations)) {
  $reservations_dropdown.append($("<option />").val(reservation).text(reservation));
}
</script>
